<?php

// Kamil: Complete, simplest possible XMLRPC Server implementation
// LINK: https://stackoverflow.com/questions/14961537/xml-rpc-server-implementation-in-php-minimal-simplest-possible

include "rpclib/xmlrpc.inc";     // from http://phpxmlrpc.sourceforge.net/ - version 3
include "rpclib/xmlrpcs.inc";    // from http://phpxmlrpc.sourceforge.net/ - version 3

// function that handles add2integer XML-RPC method 
// function "mapping" is defined in 'new xmlrpc_server' constructor parameter.
function add2integer ($xmlrpcmsg) 
{
    $summand_1 = $xmlrpcmsg->getParam(0)->scalarval(); // first parameter becomes variable $summand_1
    $summand_2 = $xmlrpcmsg->getParam(1)->scalarval(); // second parameter becomes variable $summand_2

    $result = $summand_1 + $summand_2; // calculating result

    $xmlrpcretval = new xmlrpcval($result, "int");   // creating value object - type integer
    $xmlrpcresponse = new xmlrpcresp($xmlrpcretval); // creating (new) response object

    return $xmlrpcresponse; // returning response
}

// creating XML-RPC server object that handles only 1 method
$s = new xmlrpc_server(
     array(
       "add2integer" =>  array( // xml-rpc function/method name
       "function" => "add2integer", // php function name to use when "add2integer" is called
       "signature" => array(array($xmlrpcInt, $xmlrpcInt, $xmlrpcInt)), // signature with defined IN and OUT parameter types
       "docstring" =>  'Returns sum = summand1 + summand2' // description of method
     )));

?>